SystemOrganization addCategory: #'CS528-SkeetManager'!

Error subclass: #ScoreFormatError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Error subclass: #ShooterNotFoundError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

WAComponent subclass: #ViewAddEvent
	instanceVariableNames: 'event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewAddEvent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:17'!
newWithEvent: anEvent
	^self new event: anEvent.! !

!ViewAddEvent methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 13:09'!
event
	^ event.! !

!ViewAddEvent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:21'!
event: anEvent
	event := anEvent.! !

!ViewAddEvent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:22'!
renderContentOn: html
	
	html break.
	
	event ifNil: [event := (Event newEventWithName: 'No Name').]. 
	
	html form: [
        html text: 'Event Name'.
        html textInput
            value: event name;
            callback: [ :value | event name: value ].
        html break.
	
	html text: 'Type '.
        html select 
            list: EventType allSubclasses ;
            selected: (event eventType) class;
            callback: [ :value |
                event eventType: (value new) ].
        html break.

	 html submitButton
            callback: [ self answer: event ];
            text: 'Save'.
        html cancelButton
            callback: [ self answer: nil ];
            text: 'Cancel' ]
		! !

WAComponent subclass: #ViewAddShoot
	instanceVariableNames: 'shoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewAddShoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 15:01'!
renderContentOn: html
	
	html break.
	
	html form: [
        html text: 'Shoot Name'.
        html textInput
            value: 'No Name';
            callback: [ :value | shoot := (Shoot newShootWithName: value) ].
        html break.
        html submitButton
            callback: [ self answer: shoot ];
            text: 'Save'.
        html cancelButton
            callback: [ self answer: nil ];
            text: 'Cancel' ]
		! !

!ViewAddShoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 12:59'!
shoot
	^ shoot.
		! !

WAComponent subclass: #ViewAddShooter
	instanceVariableNames: 'shooter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewAddShooter class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:52'!
newWithShooter: aShooter 
	^self new shooter: aShooter.! !

!ViewAddShooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 05:55'!
renderContentOn: html
	
	|allTypes allConcurrents allEvents |
	html break.
	 
	html form: [
        html text: 'First Name: ' .
        html textInput
            value: shooter firstName;
            callback: [ :value | shooter firstName: value ].
        html break.

	html text: 'Middle Name'.
        html textInput
            value: shooter middleName;
            callback: [ :value | shooter middleName: value].
	html break.
	
	html text: 'Last Name'.
        html textInput
            value: shooter lastName;
            callback: [ :value | shooter lastName: value].
	html break.
	
	 html text: 'Date of Birth'.
        html dateInput
		value: shooter dob;
       	 callback: [ :value | shooter dob: value ].
       html break.  

      html text: 'Membership Number'.
        html textInput
            value: shooter membershipNumber;
            callback: [ :value | shooter membershipNumber: value].
	html break.

	html text: 'Address'.
        html textInput
            value: shooter address ;
            callback: [ :value | shooter address: value].
	html break.
	
	html text: 'Phone'.
        html textInput
            value: shooter phone;
            callback: [ :value | shooter phone: value].
	html break.
	
      html text: 'Email'.
        html textInput
            value: shooter email;
            callback: [ :value | shooter email: value ].
	html break.
	
	allTypes := EventType allSubclasses.
	allTypes := allTypes collect: [:each | each new ].
	
	html break.
	html text: 'Classifications '.
	html break.
		allTypes do: [ :type|
			html text: type name.
			html space. 
			html select 
            		list: ClassType allSubclasses ;   
				selected: ((shooter classFor: type) class);        
            		callback: [ :value |
                			shooter setClass: (value new) forEvent: type  ].
			html space.
			html textInput
            		value: (shooter averageFor: type);
            		callback: [ :value | shooter setAverage: (value asNumber) forEvent: type].
			
			 ] separatedBy:[ html break.].
			
       
        html break.
	html break.
	 html text: 'Concurrents: '.
	html break.
 	allConcurrents := ConcurrentType allSubclasses.
	allConcurrents := allConcurrents collect: [ :each| each new ].
	
	allConcurrents do: [ :each |
		html checkbox
            value:  (shooter belongsToConcurrent: each) ;
            callback: [ :value | value ifTrue: [ shooter addConcurrent: each] ] .
		html text: (each class).
		html break.
		].
        html break.


	 html break.
	html break.
	 html text: 'Select Events '.
	html break.
 	allEvents := shooter shoot events.
	
	allEvents do: [ :each |
		html checkbox
            value:  (shooter enteredEvent: each) ;
            callback: [ :value | value ifTrue: [ each addShooter: shooter] ] .
		html text: (each name).
		html break.
		].
        html break.
		 
	"
        
	
  

	
    html text: 'Date of Birth'.
        html textInput
            value: 'No Name';
            callback: [ :value | shooter dob: value].
	html break.
  
    html text: 'Membership Number'.
        html textInput
            value: 'No Name';
            callback: [ :value | shooter membershipNumber: value].
	html break.

    html text: 'Classification'.
        html textInput
            value: 'No Name';
            callback: [ :value | shooter  classFor: value].
	html break.

      html text: 'Averages'.
        html textInput
            value: 'No Name';
            callback: [ :value | shooter  averageFor: value].
	html break.
	
        html text: 'concurrents'.
        html textInput
            value: 'No Name';
            callback: [ :value | shooter  concurrents ].
	html break.
	  "
        html submitButton
            callback: [ self answer: shooter ];
            text: 'Save'.
        html cancelButton
            callback: [ self answer: nil ];
            text: 'Cancel'  .].
		! !

!ViewAddShooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 14:20'!
shooter
	^ shooter.
		! !

!ViewAddShooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:53'!
shooter: aShooter
	shooter := aShooter.
		! !

WAComponent subclass: #ViewMain
	instanceVariableNames: 'addShootView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewMain class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/14/2013 14:32'!
initialize
    "self initialize"
    WAAdmin register: self asApplicationAt: 'simpleskeet'! !

!ViewMain methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 14:39'!
add
	"|newShoot|"
	"newShoot := self call: (ViewAddShoot new )."
      "newShoot isNil"
        "ifFalse: [ newShoot save ]."
	addShootView := ViewAddShoot new.
	addShootView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				addShootView shoot save. 
				
				].
			addShootView := nil.
		 ]! !

!ViewMain methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 12:48'!
children 
	^ Array with: addShootView.! !

!ViewMain methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 12:11'!
goToShoot: aShoot 
	self call: (ViewShoot new shoot: aShoot).
    ! !

!ViewMain methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/14/2013 15:10'!
remove: aShoot
	(self confirm: 'Are you sure you want to remove ' , aShoot name printString , '?')
        ifTrue: [ aShoot delete ].
    ! !

!ViewMain methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 15:27'!
renderContentOn: html
	|allShoots|
	Shoot newShootWithName: 'NewShoot'.
	allShoots := Shoot findAll.
	
	html heading:[
		html anchor 
        	callback: [ self session presenter.  ];
        	with: ('Simple Skeet').
	].


	html break.
	html anchor 
        callback: [ self add ];
        with: 'Add New Shoot'.
	html break.
	
	html render: addShootView.
	
	html unorderedList: [
		allShoots do: [:shoot | 
			html listItem with: [ 
				html anchor 
					callback: [ self goToShoot: shoot ];
           				with: shoot name. 
				html space.
				html anchor
                			callback: [ self remove: shoot ];
                			with: 'remove' ]
				].
		].
	
	
     ! !

WAComponent subclass: #ViewShoot
	instanceVariableNames: 'shoot addEventView addShooterView showShootersView showEventsView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:27'!
addEvent
	
	addEventView := ViewAddEvent new.
	addEventView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot addEvent:  ( addEventView event ). 
				shoot save.
				
				].
		addEventView := nil.
	]! !

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 05:51'!
addShooter
	
	addShooterView := ViewAddShooter new.
	addShooterView shooter: (Shooter newShooterFirstName: 'No Name' shoot: shoot).
	addShooterView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot addShooter:  ( addShooterView shooter ). 
				shoot save.
				].
		addShooterView := nil.
		 ]! !

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:30'!
children 
	^ {addEventView . addShooterView . showShootersView . showEventsView} asArray.! !

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:29'!
renderContentOn: html
	html heading: [
	html anchor 
        callback: [ self answer: nil  ];
        with: ('Simple Skeet').
	].
 
	html break.
	html break.
	html break.
	
    	html text: ('Shoot: ',(shoot name) ).
	html break.
	html break.
	
	html anchor 
        callback: [ self addEvent ];
        with: 'Add New Event'.
	html break.
	html render: addEventView.
	html break.
	
	html anchor 
        callback: [ self showEvents ];
        with: 'Show Events'.
	html break.
	html render: showEventsView.
	html break.
	
	html anchor 
        callback: [ self addShooter ];
        with: 'Add New Shooter'.
	html break.
	html render: addShooterView.
	html break.
	
	html anchor 
        callback: [ self showShooters ];
        with: 'Show Shooters'.
	html break.
	html render: showShootersView.
	html break.
	
	html text:('Number of Shooters: ', shoot shooters size asString ).
	html break.
	html text:('Number of Events: ', shoot events size asString).

	! !

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/14/2013 15:15'!
shoot
	^ shoot.! !

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/14/2013 15:15'!
shoot: aShoot
	shoot := aShoot.! !

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:28'!
showEvents
	
	showEventsView := ViewShowEvents newWithShoot: shoot.
	showEventsView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot := value. 
				
				shoot save.
			].
		showEventsView := nil.
	]! !

!ViewShoot methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:43'!
showShooters
	
	showShootersView := ViewShowShooters newWithShoot: shoot.
	showShootersView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot := value. 
				
				shoot save.
			].
		showShootersView := nil.
	]! !

WAComponent subclass: #ViewShowEvents
	instanceVariableNames: 'shoot addEventView event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewShowEvents class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:23'!
newWithShoot: aShoot 
	^self new shoot: aShoot.! !

!ViewShowEvents methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:23'!
children 
	^ { addEventView} asArray.! !

!ViewShowEvents methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:32'!
renderContentOn: html
	
	
	html break.
	html render: addEventView.
	html break.
	
	shoot events do: [ :eachEvent | 
			html text: (eachEvent name).
			html space.
			html anchor
                			callback: [ self showEvent: eachEvent ];
                			with: 'Update'.
		 ] separatedBy: [ html break. ].
	

	
	html form: [
  		
        	html cancelButton
        	    callback: [ self answer: nil ];
        	    text: 'Hide Events' ]. ! !

!ViewShowEvents methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:23'!
shoot
	^ shoot.
		! !

!ViewShowEvents methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:23'!
shoot: aShoot
	shoot := aShoot.
		! !

!ViewShowEvents methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:26'!
showEvent: anEvent
	addEventView := ViewAddEvent newWithEvent: anEvent.
	Transcript show: anEvent name.
	addEventView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot save. 
			].
			addEventView := nil.
		 ]! !

WAComponent subclass: #ViewShowShooters
	instanceVariableNames: 'shoot addShooterView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ViewShowShooters class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:40'!
newWithShoot: aShoot 
	^self new shoot: aShoot.! !

!ViewShowShooters methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:07'!
children 
	^ { addShooterView} asArray.! !

!ViewShowShooters methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 18:56'!
removeShooter: aShooter
	(self confirm: 'Are you sure you want to remove ' , aShooter name printString , '?')
        ifTrue: [ shoot removeShooter: aShooter.
		shoot save.
	 ].! !

!ViewShowShooters methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 18:30'!
renderContentOn: html
	
	
	html break.
	html render: addShooterView.
	html break.
	
	shoot shooters do: [ :shooter | 
			html text: (shooter name).
			html space.
			html anchor
                			callback: [ self showShooter: shooter ];
                			with: 'Update'.
			html space.
			html anchor
                			callback: [ self removeShooter: shooter ];
                			with: 'Remove'.
		 ] separatedBy: [ html break. ].
	

	
	html form: [
  		
        	html cancelButton
        	    callback: [ self answer: nil ];
        	    text: 'Hide Shooters' ]. ! !

!ViewShowShooters methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:32'!
shoot
	^ shoot.
		! !

!ViewShowShooters methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:40'!
shoot: aShoot
	shoot := aShoot.
		! !

!ViewShowShooters methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 19:08'!
showShooter: aShooter
	addShooterView := ViewAddShooter newWithShooter: aShooter.
	Transcript show: aShooter name.
	addShooterView onAnswer: [ :value|
		value isNil 
			ifFalse: [ 
				shoot save. 
			].
			addShooterView := nil.
		 ]! !

SDActiveRecord subclass: #Shoot
	instanceVariableNames: 'name shooters events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!Shoot class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:54'!
newShootWithName: aName 	
	^ self new shootWithName: aName.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:56'!
addEvent: anEvent
	events add: anEvent.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:56'!
addShooter: aShooter 
	shooters add: aShooter.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 12:06'!
events
	^events.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/14/2013 12:00'!
name
	^name.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/14/2013 12:00'!
printOn: aStream
	aStream nextPutAll: self name.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 18:56'!
removeShooter: aShooter 
	shooters remove: aShooter.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 16:07'!
shootWithName: aName
	name:= aName.
	shooters := OrderedCollection new.
	events := OrderedCollection new.! !

!Shoot methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 12:06'!
shooters
	^shooters.! !

TestCase subclass: #EventTestCase
	instanceVariableNames: 'event renk henry varney jenny tom1 tom2 tony randy paul greg'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!EventTestCase methodsFor: 'running' stamp: 'HenryDuwe 7/16/2013 06:10'!
setUp

	"Create an Event"
	| eventType |
	Transcript show: 'blah'.
	eventType := Gauge12 new.
	event := Event newEventWithName: '12 Ga Event' andType: eventType.
	
  	"Create some Shooters"
	renk := Shooter newShooterFirstName: 'Jeff' shoot: nil.
	renk middleName: ''; lastName: 'Renk'.
	renk addConcurrent: SeniorConcurrent new.
	renk setClass: (CClass new) forEvent: (Gauge12 new) withAverage: 0.9000.
	
	henry := Shooter newShooterFirstName: 'Henry' shoot: nil.
	henry middleName: 'John'; lastName: 'Duwe'.
	henry addConcurrent: TripleSubSeniorConcurrent new.
	henry setClass: (AClass new) forEvent: (Gauge12 new) withAverage: 0.9600.
	
	varney := Shooter newShooterFirstName: 'Jeff' shoot: nil.
	varney middleName: ''; lastName: 'Varney'.
	varney addConcurrent: TripleSubSeniorConcurrent new.
	varney setClass: (AAClass new) forEvent: (Gauge12 new) withAverage: 0.9600.
	
	jenny := Shooter newShooterFirstName: 'Jenny' shoot: nil.
	jenny middleName: ''; lastName: 'Notstad'.
	jenny addConcurrent: TripleSubSeniorConcurrent new.
	jenny addConcurrent: LadyConcurrent new.
	jenny setClass: (CClass new) forEvent: (Gauge12 new) withAverage: 0.9000.
	
	tom1 := Shooter newShooterFirstName: 'Tom' shoot: nil.
	tom1 middleName: ''; lastName: 'McDaniels'.
	tom1 addConcurrent: SeniorConcurrent new.
	tom1 setClass: (DClass new) forEvent: (Gauge12 new) withAverage: 0.8900.
	
	tom2 := Shooter newShooterFirstName: 'Tom' shoot: nil.
	tom2 middleName: ''; lastName: 'Steinbeck'.
	tom2 addConcurrent: SeniorConcurrent new.
	tom2 setClass: (BClass new) forEvent: (Gauge12 new) withAverage: 0.9100.
	
	tony := Shooter newShooterFirstName: 'Tony' shoot: nil.
	tony middleName: ''; lastName: 'Pavelka'.
	tony addConcurrent: SubSeniorConcurrent new.
	tony setClass: (EClass new) forEvent: (Gauge12 new) withAverage: 0.8500.
	
	randy := Shooter newShooterFirstName: 'Randy' shoot: nil.
	randy middleName: ''; lastName: 'Riehle'. 
	randy addConcurrent: SeniorConcurrent new.
	randy setClass: (AClass new) forEvent: (Gauge12 new) withAverage: 0.9650.

	paul := Shooter newShooterFirstName: 'Paul' shoot: nil.
	paul middleName: 'David'; lastName: 'Friesen'.
	paul addConcurrent: SeniorConcurrent new.
	paul setClass: (BClass new) forEvent: (Gauge12 new) withAverage: 0.9590.
	
	greg := Shooter newShooterFirstName: 'Greg' shoot: nil.
	greg middleName: ''; lastName: 'Schweppe'.
	greg addConcurrent: SeniorConcurrent new.
	greg setClass: (AClass new) forEvent: (Gauge12 new) withAverage: 0.9540.
	
	"Add them to Event"
	event addShooter: renk.
	event addShooter: henry.
	event addShooter: varney.
	event addShooter: jenny.
	event addShooter: tom1.
	event addShooter: tom2.
	event addShooter: tony.
	event addShooter: randy.
	event addShooter: paul.
	event addShooter: greg.! !

!EventTestCase methodsFor: 'testing' stamp: 'HenryDuwe 7/16/2013 06:13'!
testRanking
	"| honors theAHonor |"
	
	"Enter scores"
	| honors theAHonor score|
	score := OrderedCollection new.
	score add: 24; add: 24; add: 24; add: 25.
	event setScore: score for: randy.
	score := OrderedCollection new.
	score add: 24; add: 24; add: 24; add: 24.
	event setScore: score for: varney.
	score := OrderedCollection new.
	score add: 22; add: 24; add: 25; add: 25.
	event setScore: score for: henry.
	score := OrderedCollection new.
	score add: 23; add: 24; add: 23; add: 25.
	event setScore: score for: greg.
	event setScore: { 20 . 24 . 24 . 24 } for: paul.
	event setScore: { 23 . 22 . 23 . 22 } for: renk.
	event setScore: { 22 . 23 . 22 . 23 } for: jenny.
	event setScore: { 21 . 24 . 20 . 22 } for: tom1.
	event setScore: { 24 . 22 . 21 . 21 } for: tony.
	
	"Create honors and rank"
	event createHonors.
	
	"Test A Class rankings"
	honors := event honors.
	theAHonor := honors detect: [ :each | (each type) = (AClass new) ].
	self assert: ((((theAHonor rankings) at: 1) at: 1)== randy).
	self assert: ((((theAHonor rankings) at: 2) at: 1)== henry).
	self assert: ((((theAHonor rankings) at: 3) at: 1) == greg).
! !

TestCase subclass: #ShootTestCase
	instanceVariableNames: 'shoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ShootTestCase commentStamp: '<historical>' prior: 0!
A ShootTestCase tests the skeet shoot manager application in all its various ways. It includes large-scale real tests for shoots.!

!ShootTestCase methodsFor: 'running' stamp: 'HenryDuwe 7/16/2013 06:16'!
setUp 	
	shoot := Shoot newShootWithName: 'Fun Shoot'.! !

!ShootTestCase methodsFor: 'testing' stamp: 'HenryDuwe 7/16/2013 06:15'!
testAddShooter
	shoot addShooter: (Shooter newShooterFirstName: 'Dustin' shoot: shoot).
	self assert: ((shoot shooters size) = 1).
	! !

!ShootTestCase methodsFor: 'testing' stamp: 'BiplabDeka 7/14/2013 11:11'!
testDB
	| |
	"Setup shoot."
	shoot := Shoot newShootWithName: 'Mike Kipp 2013'.
	
! !

!ShootTestCase methodsFor: 'testing' stamp: 'HenryDuwe 7/16/2013 06:31'!
testMikeKipp
	| shootoffs12 event12 eventDoubles event28 event410 henry paul renk varney jenny tom1 tom2 tony randy greg |
	"Setup shoot."
	shoot := Shoot newShootWithName: 'Mike Kipp 2013'.
	eventDoubles := Event newEventWithName: 'Doubles Event' andType: (Doubles new) .
	shoot addEvent: (eventDoubles).
	event12 := Event newEventWithName: '12ga Event' andType: (Gauge12 new) .
	shoot addEvent: (event12).
	event28 := Event newEventWithName: '28ga Event' andType: (Gauge28 new) .
	shoot addEvent: (event28).
	event410 := Event newEventWithName: '410bore Event' andType: (Bore410 new) .
	shoot addEvent: (event410).
	shoot addEvent: (CompositeEvent newEventNamed: 'HOA Event' WithEvents: {event12 . event28 . event410 . eventDoubles}).
			
	"Add shooters"
	renk := Shooter newShooterFirstName: 'Jeff' shoot: nil.
	renk middleName: ''; lastName: 'Renk'.
	renk addConcurrent: SeniorConcurrent new.
	renk setClass: (CClass new) forEvent: (Gauge12 new) withAverage: 0.9000.
	
	henry := Shooter newShooterFirstName: 'Henry' shoot: nil.
	henry middleName: 'John'; lastName: 'Duwe'.
	henry addConcurrent: TripleSubSeniorConcurrent new.
	henry setClass: (AClass new) forEvent: (Gauge12 new) withAverage: 0.9600.
	
	varney := Shooter newShooterFirstName: 'Jeff' shoot: nil.
	varney middleName: ''; lastName: 'Varney'.
	varney addConcurrent: TripleSubSeniorConcurrent new.
	varney setClass: (AAClass new) forEvent: (Gauge12 new) withAverage: 0.9600.
	
	jenny := Shooter newShooterFirstName: 'Jenny' shoot: nil.
	jenny middleName: ''; lastName: 'Notstad'.
	jenny addConcurrent: TripleSubSeniorConcurrent new.
	jenny addConcurrent: LadyConcurrent new.
	jenny setClass: (CClass new) forEvent: (Gauge12 new) withAverage: 0.9000.
	
	tom1 := Shooter newShooterFirstName: 'Tom' shoot: nil.
	tom1 middleName: ''; lastName: 'McDaniels'.
	tom1 addConcurrent: SeniorConcurrent new.
	tom1 setClass: (DClass new) forEvent: (Gauge12 new) withAverage: 0.8900.
	
	tom2 := Shooter newShooterFirstName: 'Tom' shoot: nil.
	tom2 middleName: ''; lastName: 'Steinbeck'.
	tom2 addConcurrent: SeniorConcurrent new.
	tom2 setClass: (BClass new) forEvent: (Gauge12 new) withAverage: 0.9100.
	
	tony := Shooter newShooterFirstName: 'Tony' shoot: nil.
	tony middleName: ''; lastName: 'Pavelka'.
	tony addConcurrent: SubSeniorConcurrent new.
	tony setClass: (EClass new) forEvent: (Gauge12 new) withAverage: 0.8500.
	
	randy := Shooter newShooterFirstName: 'Randy' shoot: nil.
	randy middleName: ''; lastName: 'Riehle'. 
	randy addConcurrent: SeniorConcurrent new.
	randy setClass: (AClass new) forEvent: (Gauge12 new) withAverage: 0.9650.

	paul := Shooter newShooterFirstName: 'Paul' shoot: nil.
	paul middleName: 'David'; lastName: 'Friesen'.
	paul addConcurrent: SeniorConcurrent new.
	paul setClass: (BClass new) forEvent: (Gauge12 new) withAverage: 0.9590.
	
	greg := Shooter newShooterFirstName: 'Greg' shoot: nil.
	greg middleName: ''; lastName: 'Schweppe'.
	greg addConcurrent: SeniorConcurrent new.
	greg setClass: (AClass new) forEvent: (Gauge12 new) withAverage: 0.9540.
	
	"Add them to Event"
	event12 addShooter: renk.
	event12 addShooter: henry.
	event12 addShooter: varney.
	event12 addShooter: jenny.
	event12 addShooter: tom1.
	event12 addShooter: tom2.
	event12 addShooter: tony.
	event12 addShooter: randy.
	event12 addShooter: paul.
	event12 addShooter: greg.
	
	
	"Print scores by class and concurrent"
	
	"Determine shootoffs"
	shootoffs12 := event12 shootoffs.
	
	self assert: (shootoffs12 size = 0).

	"Resolve ties"
	
	
	"Print winners"

! !

Object subclass: #ClassType
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!ClassType commentStamp: '<historical>' prior: 0!
a class to hold class types.
!

ClassType subclass: #AAAClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

AAAClass class
	instanceVariableNames: 'uniqueInstance'!

AAAClass class
	instanceVariableNames: 'uniqueInstance'!

!AAAClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:38'!
new
     uniqueInstance ifNil: [uniqueInstance := self basicNew name:'AAAClass' ]. 
     ^ uniqueInstance.! !

!AAAClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:38'!
removeUnique
     
	uniqueInstance := nil.! !

!AAAClass methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:37'!
name: aString
	super name ifNil: [ super name: aString ].! !

ClassType subclass: #AAClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

AAClass class
	instanceVariableNames: 'uniqueInstance'!

AAClass class
	instanceVariableNames: 'uniqueInstance'!

!AAClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:38'!
new
     uniqueInstance ifNil: [uniqueInstance := self basicNew name:'AAClass' ]. 
     ^ uniqueInstance.! !

!AAClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:38'!
removeUnique
     
	uniqueInstance := nil.! !

!AAClass methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:37'!
name: aString
	super name ifNil: [ super name: aString ].! !

ClassType subclass: #AClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

AClass class
	instanceVariableNames: 'uniqueInstance'!

AClass class
	instanceVariableNames: 'uniqueInstance'!

!AClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:38'!
new
     uniqueInstance ifNil: [uniqueInstance := self basicNew name:'AClass' ]. 
     ^ uniqueInstance.! !

!AClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:38'!
removeUnique
     
	uniqueInstance := nil.! !

!AClass methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:37'!
name: aString
	super name ifNil: [ super name: aString ].! !

ClassType subclass: #BClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

BClass class
	instanceVariableNames: 'uniqueInstance'!

BClass class
	instanceVariableNames: 'uniqueInstance'!

!BClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:39'!
new
     uniqueInstance ifNil: [uniqueInstance := self basicNew name:'BClass' ]. 
     ^ uniqueInstance.! !

!BClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:39'!
removeUnique
     
	uniqueInstance := nil.! !

!BClass methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:37'!
name: aString
	super name ifNil: [ super name: aString ].! !

ClassType subclass: #CClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

CClass class
	instanceVariableNames: 'uniqueInstance'!

CClass class
	instanceVariableNames: 'uniqueInstance'!

!CClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:39'!
new
     uniqueInstance ifNil: [uniqueInstance := self basicNew name:'CClass' ]. 
     ^ uniqueInstance.! !

!CClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:39'!
removeUnique
     
	uniqueInstance := nil.! !

!CClass methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:37'!
name: aString
	super name ifNil: [ super name: aString ].! !

!ClassType methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:07'!
name
	^ name.! !

!ClassType methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 17:43'!
name: aString
	name := aString.! !

!ClassType methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 17:38'!
printOn: aStream
	aStream nextPutAll: self name.! !

ClassType subclass: #DClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

DClass class
	instanceVariableNames: 'uniqueInstance'!

DClass class
	instanceVariableNames: 'uniqueInstance'!

!DClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:39'!
new
     uniqueInstance ifNil: [uniqueInstance := self basicNew name:'CClass' ]. 
     ^ uniqueInstance.! !

!DClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:39'!
removeUnique
     
	uniqueInstance := nil.! !

!DClass methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:37'!
name: aString
	super name ifNil: [ super name: aString ].! !

ClassType subclass: #EClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

EClass class
	instanceVariableNames: 'uniqueInstance'!

EClass class
	instanceVariableNames: 'uniqueInstance'!

!EClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:39'!
new
     uniqueInstance ifNil: [uniqueInstance := self basicNew name:'EClass' ]. 
     ^ uniqueInstance.! !

!EClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:39'!
removeUnique
     
	uniqueInstance := nil.! !

!EClass methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:37'!
name: aString
	super name ifNil: [ super name: aString ].! !

ClassType subclass: #NCClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

NCClass class
	instanceVariableNames: 'uniqueInstance'!

NCClass class
	instanceVariableNames: 'uniqueInstance'!

!NCClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:39'!
new
     uniqueInstance ifNil: [uniqueInstance := self basicNew name:'NCClass' ]. 
     ^ uniqueInstance.! !

!NCClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:58'!
removeUnique
     
	uniqueInstance := nil.! !

!NCClass methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:37'!
name: aString
	super name ifNil: [ super name: aString ].! !

ClassType subclass: #OverallClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

OverallClass class
	instanceVariableNames: 'uniqueInstance'!

OverallClass class
	instanceVariableNames: 'uniqueInstance'!

!OverallClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
new
     uniqueInstance ifNil: [uniqueInstance := self basicNew name:'Overall' ]. 
     ^ uniqueInstance.! !

!OverallClass class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
removeUnique
     
	uniqueInstance := nil.! !

!OverallClass methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:36'!
name: aString
	super name ifNil: [ super name: aString ].! !

Object subclass: #ConcurrentType
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

ConcurrentType subclass: #ActiveMillitaryConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

ActiveMillitaryConcurrent class
	instanceVariableNames: 'uniqueInstance'!

ActiveMillitaryConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!ActiveMillitaryConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'ActiveMillitaryConcurrent']. 
     ^ uniqueInstance.! !

!ActiveMillitaryConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
removeUnique
     
	uniqueInstance := nil.! !

!ActiveMillitaryConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:34'!
name: aString
	super name ifNil: [ super name: aString ].! !

ConcurrentType subclass: #CollegiateConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

CollegiateConcurrent class
	instanceVariableNames: 'uniqueInstance'!

CollegiateConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!CollegiateConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'CollegiateConcurrent']. 
     ^ uniqueInstance.! !

!CollegiateConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
removeUnique
     
	uniqueInstance := nil.! !

!CollegiateConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:34'!
name: aString
	super name ifNil: [ super name: aString ].! !

!ConcurrentType methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:59'!
name
	^ name.! !

!ConcurrentType methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 17:44'!
name: aString
	name := aString.! !

!ConcurrentType methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 17:38'!
printOn: aStream
	aStream nextPutAll: self name.! !

ConcurrentType subclass: #JuniorConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

JuniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

JuniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!JuniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'JuniorConcurrent']. 
     ^ uniqueInstance.! !

!JuniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
removeUnique
     
	uniqueInstance := nil.! !

!JuniorConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:34'!
name: aString
	super name ifNil: [ super name: aString ].! !

ConcurrentType subclass: #LadyConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

LadyConcurrent class
	instanceVariableNames: 'uniqueInstance'!

LadyConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!LadyConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'LadyConcurrent']. 
     ^ uniqueInstance.! !

!LadyConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:40'!
removeUnique
     
	uniqueInstance := nil.! !

!LadyConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:34'!
name: aString
	super name ifNil: [ super name: aString ].! !

ConcurrentType subclass: #RetiredMillitaryConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

RetiredMillitaryConcurrent class
	instanceVariableNames: 'uniqueInstance'!

RetiredMillitaryConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!RetiredMillitaryConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'RetiredMillitaryConcurrent']. 
     ^ uniqueInstance.! !

!RetiredMillitaryConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
removeUnique
     
	uniqueInstance := nil.! !

!RetiredMillitaryConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:34'!
name: aString
	super name ifNil: [ super name: aString ].! !

ConcurrentType subclass: #SeniorConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

SeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

SeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!SeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'SeniorConcurrent']. 
     ^ uniqueInstance.! !

!SeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
removeUnique
     
	uniqueInstance := nil.! !

!SeniorConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:34'!
name: aString
	super name ifNil: [ super name: aString ].! !

ConcurrentType subclass: #SubJuniorConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

SubJuniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

SubJuniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!SubJuniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'SubJuniorConcurrent']. 
     ^ uniqueInstance.! !

!SubJuniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
removeUnique
     
	uniqueInstance := nil.! !

!SubJuniorConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:34'!
name: aString
	super name ifNil: [ super name: aString ].! !

ConcurrentType subclass: #SubSeniorConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

SubSeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

SubSeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!SubSeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'SubSeniorConcurrent']. 
     ^ uniqueInstance.! !

!SubSeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
removeUnique
     
	uniqueInstance := nil.! !

!SubSeniorConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:34'!
name: aString
	super name ifNil: [ super name: aString ].! !

ConcurrentType subclass: #SubSubSeniorConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

SubSubSeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

SubSubSeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!SubSubSeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'SubSubSeniorConcurrent']. 
     ^ uniqueInstance.! !

!SubSubSeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:41'!
removeUnique
     
	uniqueInstance := nil.! !

!SubSubSeniorConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:33'!
name: aString
	super name ifNil: [ super name: aString ].! !

ConcurrentType subclass: #TripleSubSeniorConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

TripleSubSeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

TripleSubSeniorConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!TripleSubSeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:42'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'TripleSubSeniorConcurrent']. 
     ^ uniqueInstance.! !

!TripleSubSeniorConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:42'!
removeUnique
     
	uniqueInstance := nil.! !

!TripleSubSeniorConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:33'!
name: aString
	super name ifNil: [ super name: aString ].! !

ConcurrentType subclass: #VeteranConcurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

VeteranConcurrent class
	instanceVariableNames: 'uniqueInstance'!

VeteranConcurrent class
	instanceVariableNames: 'uniqueInstance'!

!VeteranConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:42'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'VeteranConcurrent']. 
     ^ uniqueInstance.! !

!VeteranConcurrent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:42'!
removeUnique
     
	uniqueInstance := nil.! !

!VeteranConcurrent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:33'!
name: aString
	super name ifNil: [ super name: aString ].! !

Object subclass: #Database
	instanceVariableNames: 'shoots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Object subclass: #Event
	instanceVariableNames: 'name shooters eventType scores scoreFormat honors shootoffs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Event subclass: #CompositeEvent
	instanceVariableNames: 'events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!CompositeEvent class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 06:30'!
newEventNamed: aString WithEvents: aCollection 
	^(self new) name: aString; events: aCollection.! !

!CompositeEvent methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 06:29'!
events: aCollection
	events := aCollection.! !

!Event class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 18:02'!
newEventWithName: aName
	^ self new eventWithName: aName.! !

!Event class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 16:23'!
newEventWithName: aName andType: aType
	^ self new eventWithName: aName andType: aType.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 05:57'!
addShooter: aShooter
	shooters add: aShooter.
	scores at: aShooter put: (self getZeroScore).
	aShooter addEvent: self.
	
	 ! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 14:23'!
createHonors
	self createHonorsFor: 1.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 06:12'!
createHonorsFor: aNumber
	"Creates the list of Honor objects given how many places will exist. This can be done once all shooters have been entered for an Event, but before all scores are entered for the event."
	|allClasses allConcurrents concurrents tempHonor tempShooters sortedShooters rankings rank tempCollection previousScore tempScore |
	
	allClasses := OrderedCollection new.
	allConcurrents := OrderedCollection new.
	tempHonor := Honor new.
	
	
	"find all present classes and concurrents among shooters"
	shooters do: [ :shooter |
		allClasses addIfNotPresent: (shooter classFor: (self eventType)).
		concurrents := shooter concurrents.
		concurrents do: [ :concurrent | 
			allConcurrents addIfNotPresent: concurrent.
			 ]
		 ].
	
	"add an overall honor with all shooters"
	tempHonor := Honor newForEvent: self type: (OverallClass new)  numPositions: aNumber.
	tempHonor addShooters: shooters.
	honors add:  tempHonor.
	
	"for each class create a list of shooters and construct an honor for it"
	allClasses do: [ :class | 
		tempShooters := shooters select: [ :shooter | (shooter classFor: eventType) = class ].
		tempHonor := Honor newForEvent: self type: class numPositions: aNumber.
		tempHonor addShooters: tempShooters.
		honors add: tempHonor. 
		
		].
	
	"for each concurrent create a list of shooters and construct an honor for it"
	allConcurrents do: [ :concurrent | 
		tempShooters := shooters select: [ :shooter | (shooter concurrents) includes: concurrent ].
		tempHonor := Honor newForEvent: self type: concurrent  numPositions: aNumber.
		tempHonor addShooters: tempShooters.
		honors add: tempHonor. 
		].
	
	
	" now generate the rankings for each honor"
	
	honors do: [ :honor |
		sortedShooters := (honor shooters) asSortedCollection: [ :x :y | (self getTotalScoreFor: x) > (self getTotalScoreFor: y)  ]. 
		rankings := Dictionary new.
		rank :=1.
		tempCollection := OrderedCollection new.
		rankings at: rank put: tempCollection.
		
		previousScore := self getMaxTotalScore + 1.
		sortedShooters do: [ :each |
			tempScore := self getTotalScoreFor: each.
			( tempScore = previousScore) 
				ifTrue: [
					tempCollection add: each ]
				ifFalse: [ 
					tempCollection := OrderedCollection new.
					rankings at: rank put: tempCollection.
					rank := rank +1.
					tempCollection add: each.
					previousScore := tempScore.
				].
			 ].
		
		honor rankings: rankings.
	]. 

	! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 16:24'!
eventType 
	^eventType.! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 13:18'!
eventType: aType
	eventType := aType.! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 13:17'!
eventWithName: aName 
	name:= aName.
	shooters := OrderedCollection new.
	scores := Dictionary new. "key is the name of a shooter. Value is a collection of scores."
	scoreFormat := OrderedCollection new.
	scoreFormat add: 25; add: 25; add: 25 ; add: 25. "this is just a collection. Length of the collection specifies the number of rounds. Value of each element is the maximum score that can be entered for each round"
	shootoffs  := OrderedCollection new.
	honors := OrderedCollection new.
	eventType := Gauge12 new.
	
	! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 16:14'!
eventWithName: aName andType: aType
	name:= aName.
	shooters := OrderedCollection new.
	scores := Dictionary new. "key is the name of a shooter. Value is a collection of scores."
	scoreFormat := OrderedCollection new.
	scoreFormat add: 25; add: 25; add: 25 ; add: 25. "this is just a collection. Length of the collection specifies the number of rounds. Value of each element is the maximum score that can be entered for each round"
	shootoffs  := OrderedCollection new.
	honors := OrderedCollection new.
	eventType := aType.
	
	! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/8/2013 13:54'!
generateHonors
	"I attempt to assign the winner of each already created honor. If there are ties, I generate shootoffs."
! !

!Event methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/8/2013 15:43'!
generateHonors: aNumber 
	"I attempt to assign the winner of each already created honor. If there are ties, I generate shootoffs."
	|sortedShooters rankings rank tempCollection sizeoftemp total |
	
	honors do: [ :honor|
		sortedShooters := (honor shooters) asSortedCollection: [ :x :y | (self getTotalScoreFor: x) > (self getTotalScoreFor: y)  ]. 
		rankings := Dictionary new.
		rank :=1.
		tempCollection := Collection new.
		tempCollection add: (sortedShooters at: 0 ).
		
		
		1 to:  ((sortedShooters size) -1)  do: [ :i|
			((self getTotalScoreFor: i) = (self getTotalScoreFor: (i-1))) 
				ifTrue: [
					tempCollection add: (sortedShooters at: i )]
				ifFalse: [ 
					rankings at: rank put: tempCollection.
					rank := rank +1.
					tempCollection := Collection new.
					tempCollection add: (sortedShooters at: i ).
				].
			 ].
		
		honor rankings: rankings.
		total:=0.
		1 to: (aNumber) do: [ :i|
			tempCollection = honor rankings at: i.
			sizeoftemp := tempCollection size .
		      ((sizeoftemp>1)&(total<aNumber ))
		      ifTrue: [self generateShootOffFor:honor Between:tempCollection.
			total:=total+sizeoftemp.
			]
		      ifFalse: [total:=total+1]
			 ]
 		
	]. ! !

!Event methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/8/2013 21:40'!
generateShootOffFor: anHonor Between: someShooters
	"Generates a single shootoff for a particular honor between a collection of shooters. It adds the shootoff to the Event's Collection of shootoffs. "
       (self resolvedWith: someShooters =true)
       ifTrue:[self generateHonors]
	 
	! !

!Event methodsFor: 'helper methods' stamp: 'HenryDuwe 7/9/2013 19:29'!
getMaxTotalScore
	" return a collection of zeros that is the same length as the score format"
	|maxscore|
	maxscore := 0.
	maxscore := scoreFormat inject:  maxscore into: [ :total :score | total + score].
	^ maxscore.
	! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 17:03'!
getTotalScoreFor: aShooter
	^ (scores at: aShooter ifAbsent: [ ShooterNotFoundError signal ] ) sum.! !

!Event methodsFor: 'helper methods' stamp: 'HenryDuwe 7/9/2013 16:16'!
getZeroScore
	" return a collection of zeros that is the same length as the score format"
	|zeroscore|
	zeroscore := OrderedCollection new.
	scoreFormat do: [ :score | zeroscore add: 0].
	
	^ zeroscore.
	! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:27'!
honors 
	^honors.! !

!Event methodsFor: 'helper methods' stamp: 'HenryDuwe 7/9/2013 16:24'!
isScoreValid: aScore
	|bool|
	bool := true.
	( aScore size == scoreFormat size ) ifFalse:  [bool := false] ifTrue: [
		aScore with: scoreFormat collect: [:score :bound | (score > bound) ifTrue: [bool:= false]]
		].
	
	

	^bool! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:22'!
name 
	^name.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:30'!
name: aName
	name := aName.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:45'!
printOn: aStream
	self name printOn: aStream.! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 16:15'!
removeNC
	"process all NC class shooters and put them in appropriate class"
	.! !

!Event methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 16:10'!
removeShooter: aShooter
	shooters remove:  aShooter.
	scores remove:  (aShooter name) .
	
	 ! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 16:34'!
setScore: aScore for: aShooter
	(self isScoreValid: aScore) 
		ifTrue: [ 
			scores at: aShooter put: aScore.
		]
		ifFalse: [ 
			ScoreFormatError signal.
		]! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:22'!
shooters
	^shooters.! !

!Event methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:27'!
shootoffs
	^shootoffs.! !

Event subclass: #RealEvent
	instanceVariableNames: 'eventType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Object subclass: #EventType
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

EventType subclass: #Bore410
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Bore410 class
	instanceVariableNames: 'uniqueInstance'!

Bore410 class
	instanceVariableNames: 'uniqueInstance'!

!Bore410 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:33'!
new 
	uniqueInstance ifNil: [
		uniqueInstance := self basicNew name:'Bore410']. 
     ^ uniqueInstance.! !

!Bore410 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:29'!
removeUnique
     
	uniqueInstance := nil.! !

!Bore410 methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:29'!
name: aString
	super name ifNil: [ super name: aString ].! !

EventType subclass: #Doubles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Doubles class
	instanceVariableNames: 'uniqueInstance'!

Doubles class
	instanceVariableNames: 'uniqueInstance'!

!Doubles class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:31'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'Doubles']. 
     ^ uniqueInstance.! !

!Doubles class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:29'!
removeUnique
     
	uniqueInstance := nil.! !

!Doubles methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:29'!
name: aString
	super name ifNil: [ super name: aString ].! !

!EventType methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/5/2013 20:22'!
name
	^name.! !

!EventType methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 17:44'!
name: aString
	name := aString.! !

!EventType methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 17:38'!
printOn: aStream
	aStream nextPutAll: self name.! !

EventType subclass: #Gauge12
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Gauge12 class
	instanceVariableNames: 'uniqueInstance'!

Gauge12 class
	instanceVariableNames: 'uniqueInstance'!

!Gauge12 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:31'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name: 'Gauge12']. 
     ^ uniqueInstance.! !

!Gauge12 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:18'!
removeUnique
     
	uniqueInstance := nil.! !

!Gauge12 methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:23'!
name: aString
	super name ifNil: [ super name: aString ].! !

EventType subclass: #Gauge20
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Gauge20 class
	instanceVariableNames: 'uniqueInstance'!

Gauge20 class
	instanceVariableNames: 'uniqueInstance'!

!Gauge20 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:30'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'Gauge20']. 
     ^ uniqueInstance.! !

!Gauge20 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:29'!
removeUnique
     
	uniqueInstance := nil.! !

!Gauge20 methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:28'!
name: aString
	super name ifNil: [ super name: aString ].! !

EventType subclass: #Gauge28
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

Gauge28 class
	instanceVariableNames: 'uniqueInstance'!

Gauge28 class
	instanceVariableNames: 'uniqueInstance'!

!Gauge28 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:31'!
new 
     
	uniqueInstance ifNil: [uniqueInstance := self basicNew name:'Gauge28']. 
     ^ uniqueInstance.! !

!Gauge28 class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:30'!
removeUnique
     
	uniqueInstance := nil.! !

!Gauge28 methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 18:29'!
name: aString
	super name ifNil: [ super name: aString ].! !

Object subclass: #Honor
	instanceVariableNames: 'event type shooters numPositions winners rankings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!Honor class methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/7/2013 14:36'!
newForEvent: anEvent type: aType numPositions: aNumber 	
	^ self new event: anEvent type: aType numPositions: aNumber 	 ! !

!Honor methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/7/2013 14:47'!
addShooters: aCollection
	aCollection do: [ :shooter |
		shooters addIfNotPresent: shooter.
		 ].! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:48'!
event
	^event.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 16:06'!
event: anEvent type: aType numPositions: aNumber
	event := anEvent.
	type := aType.
	numPositions := aNumber.
	shooters := OrderedCollection new.
	winners := OrderedCollection new.
	rankings := Dictionary new.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 19:02'!
numPositions 
	^numPositions.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 17:37'!
printOn: aStream
	event printOn: aStream.
	aStream nextPutAll: ': '.
	type printOn: aStream.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/7/2013 16:35'!
rankings 
	^rankings.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/7/2013 16:35'!
rankings: aDictionary 
	rankings := aDictionary .! !

!Honor methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/7/2013 16:00'!
shooters
	^shooters.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:48'!
type 
	^type.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:49'!
winners 
	^winners.! !

!Honor methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/7/2013 16:10'!
winners: aList 
	winners := aList.! !

Object subclass: #Shooter
	instanceVariableNames: 'uuid firstName lastName middleName dob membershipNumber classifications averages concurrents address phone email shoot events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!Shooter class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 05:48'!
newShooterFirstName: first shoot: aShoot
	| aShooter |
	aShooter := self new.
	aShooter firstName: first; shoot: aShoot.
	^aShooter.! !

!Shooter methodsFor: 'concurrent related' stamp: 'HenryDuwe 7/9/2013 18:51'!
addConcurrent: aConcurrent 
	concurrents add: aConcurrent.
! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 05:44'!
addEvent: anEvent 
	events add: anEvent.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:14'!
address
	^ address.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 19:01'!
address: anAddress 
	 address := anAddress.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/8/2013 14:09'!
averageFor: anEventType
	^  averages at: anEventType.! !

!Shooter methodsFor: 'concurrent related' stamp: 'HenryDuwe 7/9/2013 18:53'!
belongsToConcurrent: aConcurrent 
	concurrents indexOf: aConcurrent ifAbsent: [^ false].
	^true.
! !

!Shooter methodsFor: 'class related' stamp: 'BiplabDeka 7/8/2013 14:10'!
classFor: anEventType
	^ classifications at:anEventType .! !

!Shooter methodsFor: 'class related' stamp: 'BiplabDeka 7/5/2013 16:27'!
concurrents
^ concurrents .! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:53'!
dob
	^dob.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:34'!
dob: aDate  	
	dob := aDate.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:14'!
email  
	^ email.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 19:00'!
email: anEmail   
	email := anEmail.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 05:56'!
enteredEvent: anEvent 
	^events includes: anEvent.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 05:44'!
events
	^events.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:56'!
firstName
	^firstName.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 05:46'!
firstName: first 
	|allTypes|
	firstName:= first.
	middleName:= '' .
	lastName:= ''.
	dob:= Date newDay: 1 month:1  year:1900.
	address:='your address'.
	membershipNumber:='0AB123'.
	uuid:= firstName,'_',middleName,'_',lastName.
	phone := 1112223333.
	email := 'yourname@example.com'.
	
	classifications := Dictionary new. " key is event type. value is a Class type."
	averages := Dictionary new. " key is event type. value is a number."	
	allTypes := EventType allSubclasses.
	allTypes do: [ :type |
		classifications at: (type new) put: (NCClass new) .
		averages at: (type new) put: 0.
		 ].
	
	concurrents := OrderedCollection new. "list of concurrent objects stored as names"
	events := OrderedCollection new. "list of Events in which I am participating."
	
	

	 ! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/8/2013 14:10'!
getClass: anEventType 
	" return a class is event is present. else return a NC with avergae zero"
	^ classifications at: (anEventType) ifAbsent: (ClassType newNCClass: 0) .! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:56'!
lastName
	^lastName.! !

!Shooter methodsFor: 'class related' stamp: 'BiplabDeka 7/15/2013 14:24'!
lastName: name 
	lastName:= name .
	uuid:= firstName,'_',middleName,'_',lastName.
	! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 17:55'!
membershipNumber	
	^ membershipNumber .! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/4/2013 17:35'!
membershipNumber: aNumber  	
	membershipNumber := aNumber.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 16:55'!
middleName
	^middleName.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'BiplabDeka 7/15/2013 14:23'!
middleName: name 
	middleName:= name .
	uuid:= firstName,'_',middleName,'_',lastName.
	! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 17:36'!
name
	^ firstName,' ',middleName,' ',lastName.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:14'!
phone 
	^ phone.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 19:00'!
phone: number 
	phone := number.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/9/2013 17:11'!
printOn: aStream 
	aStream nextPutAll: (self name).! !

!Shooter methodsFor: 'class related' stamp: 'HenryDuwe 7/15/2013 18:07'!
setAverage: anAverage forEvent: anEventType
	
	
	averages at: (anEventType ) put: anAverage.! !

!Shooter methodsFor: 'class related' stamp: 'HenryDuwe 7/15/2013 18:06'!
setClass: aClass forEvent: anEventType 
	
	classifications at: (anEventType ) put: (aClass) .
	! !

!Shooter methodsFor: 'class related' stamp: 'BiplabDeka 7/8/2013 14:34'!
setClass: aClass forEvent: anEventType withAverage: anAverage
	
	classifications at: (anEventType ) put: (aClass) .
	averages at: (anEventType ) put: anAverage.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 05:43'!
shoot
	^shoot.! !

!Shooter methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/16/2013 05:43'!
shoot: aShoot
	shoot := aShoot.! !

Object subclass: #Shootoff
	instanceVariableNames: 'shooters resolved honor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:40'!
honor 
	^honor.! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:40'!
resolved
	^resolved.! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'LiulinZhong 7/8/2013 15:50'!
resolvedWith:  someShooters 
	shooters := someShooters.
	resolved := true.
	"AND SOME MORE THINGS, such as calling honor to assign the winners, etc."
	^true! !

!Shootoff methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/4/2013 14:40'!
shooters
	^shooters.! !

Object subclass: #SkeetManagerInit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-SkeetManager'!

!SkeetManagerInit class methodsFor: 'as yet unclassified' stamp: 'HenryDuwe 7/15/2013 15:36'!
initialize 
	ZnZincServerAdaptor startOn: 8080.
	ViewMain new.
	ViewMain initialize.
	Shoot warmUp.! !
ViewMain initialize!
SkeetManagerInit initialize!
